package cpp_flowchart;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

public abstract class MyDialog extends JDialog implements ActionListener{
	private static final long serialVersionUID = 1L;
	static FocusListener focus_listener;
	
	static
	{
		focus_listener = new FocusListener(){

			@Override
			public void focusGained(FocusEvent e) {
				JTextField f = (JTextField)e.getSource();
				f.selectAll();
			}

			@Override
			public void focusLost(FocusEvent arg0) {
			}};
	}
	
	public MyDialog()
	{
		setModalityType(ModalityType.APPLICATION_MODAL);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		//ESCでdisposeするための処理
		InputMap imap = this.getRootPane().getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);
		imap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "closeMe");
		getRootPane().getActionMap().put("closeMe", new AbstractAction(){
			private static final long serialVersionUID = 1L;

			@Override
			public void actionPerformed(ActionEvent e) {
				dispose();
			}});
	}

	void grabFocus(JTextField f)
	{
		f.addFocusListener(focus_listener);
	}
	

}
