package cpp_flowchart;

import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

//import com.itextpdf.text.pdf.PdfContentByte;

public class Parts_Bar extends Parts {
	static public final int near_distance = 20;

	public Parts_Bar()
	{
		super();
	}

	@Override
	public int getHeight() {
		return size * 4;
	}

	@Override
	public int getWidth() {
		return 0;
	}

	@Override
	public boolean inside(int x, int y)
	{
		return getY1() <= y && getY2() >= y &&
				getX1() - near_distance <= x && getX2() + near_distance >= x;
	}

	@Override
	public Parts paint(Graphics g, FontMetrics fm, Point p) {
		setP1(p);
		p.y += getHeight();
		setP2(p);
		g.drawLine(getX1(), getY1(), getX2(), getY2());
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paint(g, fm, p);
	}

	@Override
	public void setSize(Graphics g, FontMetrics fm) {
		// do nothing
	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		if(getLeft() != empty) return getLeft().appendTo(sb, indentLevel);
		return this;
	}

	@Override
	public boolean dispMenu(final Flowchart chart, MouseEvent e)
	{
		Parts paste_parts = chart.getFromClipboard();
		if(paste_parts == null)return false;
		JPopupMenu popup = new JPopupMenu();
		JMenuItem item = new JMenuItem("ペースト");
		item.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				Parts paste = chart.getFromClipboard();
				Parts bar   = new Parts_Bar();
				Parts next  = left;
				left = paste;
				paste.getBlockEnd().setLeft(bar);
				bar.setLeft(next);
				chart.moveToClipboard(null);
				chart.makeDirty();
				chart.repaint();
			}});
		popup.add(item);
		popup.show(e.getComponent(), e.getX(), e.getY());
		return true;
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		if(getLeft() != empty && !getLeft().isRecursiveEnd())
			return getLeft().makeXML(doc, parent);
		return this;
	}
/*
	@Override
	public Parts paintPdf(PdfContentByte cb, int height, Graphics g,
			FontMetrics fm, Point p) {
		setP1(p);
		p.y += getHeight();
		setP2(p);
		g.drawLine(getX1(), getY1(), getX2(), getY2());
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paintPdf(cb, height, g, fm, p);
	}
*/

}
