package cpp_flowchart;

import java.awt.event.ActionEvent;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class Parts_LoopBegin1 extends Parts_LoopBegin {
	String text2;

	public Parts_LoopBegin1()
	{
		super();
		setValue("≪条件≫");
		text2 = "の間";
	}

	@Override
	public boolean hasText()
	{
		return true;
	}

	public void setValue(String s)
	{
		setText(s);
	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		Parts pNext = this;
		makeIndent(sb, indentLevel);
		sb.append("\twhile(" + getText() + "){\n");
		if(getLeft() != null)
		{
			pNext = getLeft().appendTo(sb, indentLevel + 1);
			if(getLeft().getLeft().isRecursiveEnd())
			{
				makeIndent(sb, indentLevel + 1);
				sb.append("\n");
			}
		}
		makeIndent(sb, indentLevel);
		sb.append("\t}\n");
		return pNext.getLeft().appendTo(sb, indentLevel);
	}

	@Override
	public boolean editMe()
	{
		EditDialog dialog = new EditDialog();
		dialog.setVisible(true);
		return isDirty();
	}

	private class EditDialog extends MyDialog
	{
		private static final long serialVersionUID = 1L;
		JButton btnOK, btnCancel;
		JTextField text;

		public EditDialog() {
			super();
			this.setTitle("繰り返しの編集");
			JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			text = new JTextField(40);
			grabFocus(text);
			text.setText(getText());
			btnOK = new JButton("OK");
			btnOK.addActionListener(this);
			getRootPane().setDefaultButton(btnOK);
			btnCancel = new JButton("キャンセル");
			btnCancel.addActionListener(this);
			panel.add(new JLabel("条件（〜の間）"));
			panel.add(text);
			panel.add(btnOK);
			panel.add(btnCancel);
			getContentPane().add(panel);
			pack();
			setLocationRelativeTo(null);
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == btnOK)
			{
				setValue(Converter.Zen2Han(text.getText()));
				makeDirty();
				dispose();
			}
			else if(e.getSource() == btnCancel)
				dispose();
		}
	}

	@Override
	String getText2() {
		return text2;
	}

	@Override
	void setText2(String s) {
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		Element elem = doc.createElement("while");
		elem.setAttribute("condition", getText());
		Parts parts_end = left.makeXML(doc, elem).getLeft();
		parent.appendChild(elem);
		if(parts_end.getLeft() != null && !parts_end.getLeft().isRecursiveEnd())
			return parts_end.getLeft().makeXML(doc, parent);
		return parts_end;
	}

}
