package cpp_flowchart;

import java.awt.Dimension;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class VariablePanel extends JPanel implements DocumentListener{
	private static final long serialVersionUID = 1L;
	private JTextField textInt, textFloat, textString, textBoolean;
//	private Flowchart chart;
	private CppFlowchartPanel parent;
	boolean dirty;

	public VariablePanel(CppFlowchartPanel parent)
	{
		super();
		this.parent = parent;
		dirty = false;
//		setLayout(new BorderLayout());
//		setPreferredSize(new Dimension(300,140));
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		textInt = new JTextField(20);
		textFloat = new JTextField(20);
		textString = new JTextField(20);
		textBoolean = new JTextField(20);
		textInt.getDocument().addDocumentListener(this);
		textFloat.getDocument().addDocumentListener(this);
		textString.getDocument().addDocumentListener(this);
		textBoolean.getDocument().addDocumentListener(this);
		Dimension sz = textInt.getPreferredSize();
		sz.width = Short.MAX_VALUE;
		textInt.setMaximumSize(sz);
		textFloat.setMaximumSize(sz);
		textString.setMaximumSize(sz);
		textBoolean.setMaximumSize(sz);
		JPanel subPanel = new JPanel();
		subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.X_AXIS));
		subPanel.add(new JLabel("int    "));
		subPanel.add(textInt);
		add(subPanel);
		subPanel = new JPanel();
		subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.X_AXIS));
		subPanel.add(new JLabel("double "));
		subPanel.add(textFloat);
		add(subPanel);
		subPanel = new JPanel();
		subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.X_AXIS));
		subPanel.add(new JLabel("string "));
		subPanel.add(textString);
		add(subPanel);
		subPanel = new JPanel();
		subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.X_AXIS));
		subPanel.add(new JLabel("bool   "));
		subPanel.add(textBoolean);
		add(subPanel);
		sz = getPreferredSize();
		sz.width = Short.MAX_VALUE;
		setMaximumSize(sz);
	}

//	public void setFlowchart(Flowchart c)
//	{
//		chart = c;
//	}

	public void reset()
	{
		textInt.setText("");
		textFloat.setText("");
		textString.setText("");
		textBoolean.setText("");
		makeClean();
	}

	public boolean isDirty()
	{
		return dirty;
	}

	public void makeDirty()
	{
		if(!dirty)
		{
			dirty =true;
			parent.setTitle();
		}
		else dirty = true;
	}

	public void makeClean()
	{
		if(dirty)
		{
			dirty = false;
			parent.setTitle();
		}
		else dirty = false;
	}

	public void setVars(String[] s)
	{
		textInt.setText(s[0]);
		textFloat.setText(s[1]);
		textString.setText(s[2]);
		textBoolean.setText(s[3]);
	}

	public StringBuilder clearText()
	{
		StringBuilder sb = new StringBuilder();
		String var = textInt.getText().trim();
		if(var.length() > 0) sb.append("整数 " + var + "\n");
		var = textFloat.getText().trim();
		if(var.length() > 0) sb.append("実数 " + var + "\n");
		var = textString.getText().trim();
		if(var.length() > 0) sb.append("文字列 " + var + "\n");
		var = textBoolean.getText().trim();
		if(var.length() > 0) sb.append("真偽 " + var + "\n");
		return sb;
	}

	public String getIntVars()
	{
		return textInt.getText().trim();
	}

	public String getFloatVars()
	{
		return textFloat.getText().trim();
	}

	public String getStringVars()
	{
		return textString.getText().trim();
	}

	public String getBooleanVars()
	{
		return textBoolean.getText().trim();
	}

	public void setIntVars(String s)
	{
		textInt.setText(s);
	}

	public void setFloatVars(String s)
	{
		textFloat.setText(s);
	}

	public void setStringVars(String s)
	{
		textString.setText(s);
	}

	public void setBooleanVars(String s)
	{
		textBoolean.setText(s);
	}


	@Override
	public void changedUpdate(DocumentEvent e) {
		makeDirty();
		parent.makeCode();
		parent.refreshCode();
		parent.setTitle();
	}

	@Override
	public void insertUpdate(DocumentEvent arg0) {
		makeDirty();
		parent.makeCode();
		parent.refreshCode();
		parent.setTitle();
	}

	@Override
	public void removeUpdate(DocumentEvent arg0) {
		makeDirty();
		parent.makeCode();
		parent.refreshCode();
		parent.setTitle();
	}
}
